function activeLocTest()
    local name = osrs.ClientOp.loc_name()
    local width = osrs.ClientOp.loc_width()
    local length = osrs.ClientOp.loc_length()
    local type = osrs.ClientOp.loc_type()
    local coord = osrs.ClientOp.loc_coord(false)
    for i=0,width-1 do
        osrs.ClientOp.highlight_tile_on(coord:toBitPacked() + i, 6, true)
        for j=0,length-1 do
            osrs.ClientOp.highlight_tile_on(coord:toBitPacked() + (j * 16384) + i, 6, true)
        end
    end
    local op1 = osrs.ClientOp.loc_getop(1, 1)
    local op2 = osrs.ClientOp.loc_getop(1, 2)
    local op3 = osrs.ClientOp.loc_getop(1, 3)
    local op4 = osrs.ClientOp.loc_getop(1, 4)
    local op5 = osrs.ClientOp.loc_getop(1, 5)
    osrs.print(string.format("'%s' | TYPE:%i | X:%i, Y:%i, Z:%i | PACKED COORD:%i | WIDTH:%i, LENGTH:%i | OPS: %s, %s, %s, %s, %s\n", 
        name, type, coord.x, coord.y, coord.z, coord:toBitPacked(), width, length, op1, op2, op3, op4, op5))
end

function nearbyLocTest(searchRadius)
    local playerCoord = osrs.ClientOp.coord(false)
    for x = playerCoord.x - searchRadius, playerCoord.x + searchRadius, 1 do
        for z = playerCoord.z - searchRadius, playerCoord.z + searchRadius, 1 do
            local currentCoord = osrs.Coord.new(playerCoord.level, x, z, false, false)
            local foundLoc = osrs.ClientOp.loc_find(1278, currentCoord:toBitPacked())

            if foundLoc then
                osrs.print(string.format("Searching for Tree loc '1278' at coordinate '%i'...\n==========FOUND==========\n", currentCoord:toBitPacked()))
                osrs.ClientOp.highlight_tile_on(currentCoord:toBitPacked(), 6, true)
            end
        end
    end    
end

function onKeyDown(keycode)
    if keycode == 42 then
        nearbyLocTest(3)
    elseif keycode == 43 then
        activeLocTest()
    elseif keycode == 65 then -- X
        local playerCoord = osrs.ClientOp.coord(true)
        osrs.print(string.format("Player packed coordinates '%i'", playerCoord:toBitPacked()))
    end
end

function startUp()
    osrs.print("Loc-Checker Controls:")
    osrs.print("'[' - Highlight nearby Tree locs that are of type ID '1278'")
    osrs.print("']' - Highlight & print information about the last active loc.")
    callbackID = osrs.Events:subscribe(onKeyDown, osrs.Events.KEY_DOWN, callbackID)
end

startUp()
